/*
	wmkxfapi.h
	
	by sava/LP-Project. 1998
*/


#ifndef WMKXFAPI_H__
#define WMKXFAPI_H__

#define FONTX2ID			"FONTX2"

#define WMKXF_NOERR			0
#define WMKXF_ERR_HDR		2
#define WMKXF_ERR_RGN		3
#define WMKXF_ERR_FILE		0x11
#define WMKXF_ERR_MEM		0x21
#define WMKXF_ERR_UNKNOWN	0xff

#define WMKXF_ALIGN_DEFAULT	0
#define WMKXF_ALIGN_CENTER	0x1

#ifdef __cplusplus
extern "C" {
#endif


#if defined(WIN32) || defined(_WIN32)
#pragma pack(1)
#endif

typedef struct _fontxrgn {
	WORD		rgn_begin;
	WORD		rgn_end;
} FONTXRGN, FAR * LPFONTXRGN;

typedef struct _fonxhdr {
	BYTE		id[6];
	BYTE		name[8];
	BYTE		width;
	BYTE		height;
	BYTE		flag;
} FONTXHDR, FAR * LPFONTXHDR;

typedef struct _fontxdbcshdr {
	BYTE		id[6];
	BYTE		name[8];
	BYTE		width;
	BYTE		height;
	BYTE		flag;
	BYTE		cnt_rgn;
	FONTXRGN	rgn[1];
} FONTXDBCSHDR, FAR * LPFONTXDBCSHDR;


typedef struct _wmkxfdata {
	LPARAM		user_data;
	DWORD		progress_code;
	DWORD		progress_count;
	DWORD		total_count;
} WMKXFDATA, FAR * LPWMKXFDATA;


#if defined(WIN32) || defined(_WIN32)
#pragma pack()
#endif


typedef int (*	WMKXFCALLBACKPROC)(LPWMKXFDATA);
typedef int (*	WMKXFWRITEPROC)(LPVOID, int, LPDWORD);


int wmkxfQueryTotalSize(LPDWORD, LPFONTXHDR);
int wmkxfFontToMem(LPFONTXDBCSHDR, HFONT, LPVOID, DWORD, WMKXFCALLBACKPROC, LPARAM);
int wmkxfFontToFile(LPFONTXDBCSHDR, HFONT, HANDLE, DWORD, WMKXFCALLBACKPROC, LPARAM);

#ifdef __cplusplus
}
#endif

#endif
